@import "../../styles/consts.styl"

$label-width = 200px;
$left-indent = 5px;
$bottom-indent = 5px;

$default-opacity=0.8;
$hover-opacity=0.9;
$focus-opacity=1.0;

$default-border-color=#909090;
$hover-amount=20
$hover-border-color=darken($default-border-color, $hover-amount);
$disabled-color=#909090;

$error-border-color=red;
$error-color=red;
$error-opacity=1.0;

$warning-border-color=orange;
$warning-color=orange;
$warning-opacity=1.0;

$placeholder-disabled=#606060;
$placeholder-focus=#F1F1F1;

:host {
    width: 100%;
    display: inline-block;
    min-width: 600px;
    padding: 0;
    overflow: visible;
    line-height: $line-height;
    margin-left: 5px;
    margin-top: 0;
    margin-right: 0;
    margin-bottom: $bottom-indent;

    .clearfix:after
    {
        content: "";
        visibility: hidden;
        display: block;
        height: 0;
        clear: both;
    }

    .field {
        padding-left: $left-indent;
        padding-right: 13px;
        position: relative;
    
        .field-label {
            float: left;
            width: $label-width;
            overflow: hidden;
            text-overflow: ellipsis;
            white-space: nowrap;
            border-top: 2px solid transparent;
            border-bottom: 2px solid transparent;
        }

        .field-value {
            margin-left: $label-width+$left-indent;
            margin-bottom: $bottom-indent;    
            
            .field-value-input-wrapper {
                border: solid 1px $default-border-color;

                .field-value-input {
                    border: solid 1px transparent;
                    
                    .value-input-ex-symbol {
                        display: none;
                        opacity: $default-opacity;
                    }

                    .value-input-body {
                        opacity: $default-opacity;
                        margin: 0px 3px;

                        input {
                            width: 100%;
                            margin: 0;
                            border: none;
                            display: block;
                        }
                        input:focus {
                            outline: none;
                        }
                        input:focus::-webkit-input-placeholder {
                            color:$placeholder-focus;
                        }
                        input:focus::-moz-placeholder {
                            color:$placeholder-focus;
                        }
                        input:focus:-moz-placeholder {
                            color:$placeholder-focus;
                        }
                        input:focus:-ms-input-placeholder {
                            color:$placeholder-focus;
                        }
                        input:disabled {
                            background: $disabled-color;
                        }
                        input:disabled::-webkit-input-placeholder {
                            color:$placeholder-disabled;
                        }
                        input:disabled::-moz-placeholder {
                            color:$placeholder-disabled;
                        }
                        input:disabled:-moz-placeholder {
                            color:$placeholder-disabled;
                        }
                        input:disabled:-ms-input-placeholder {
                            color:$placeholder-disabled;
                        }
                    }
                }

                .field-value-input.ex-symbol {
                    .value-input-ex-symbol {
                        display: block;
                        line-height: $line-height;
                        float: right;
                        width: 20px;
                        overflow: hidden;
                        text-align: center;
                        
                        .fa {
                            display: inline-block;
                            line-height: $line-height;
                        }
                    }

                    .value-input-body {
                        margin-right: 20px;
                    }
                }
            }
        }

        .field-required-content {
            display: none;
            position: absolute;
            right: 0;
            top: 0;
            line-height: $line-height;
            padding-right: 2px;
            border-top: solid 2px transparent;

            i {
                line-height: $line-height;
                color: red;
            }
        }
    }

    .field.required .field-required-content {
        display: block;
    }

    .field.error {
        .field-value {
            .field-value-input-wrapper {
                border-color: $error-border-color;

                .field-value-input {
                    border-color: $error-border-color;
                    
                    .value-input-body {
                        opacity: $error-opacity;
                    }
                    
                    .value-input-ex-symbol {
                        opacity: $error-opacity;
                    }
                }
            }

            .field-value-message {
                color: $error-color;
                font-weight: bolder;
            }
        }
    }

    .field.warning {
        .field-value {
            .field-value-input-wrapper {
                border-color: $warning-border-color;

                .field-value-input {
                    border-color: $warning-border-color;
                    
                    .value-input-body {
                        opacity: $warning-opacity;
                    }
                    
                    .value-input-ex-symbol {
                        opacity: $warning-opacity;
                    }
                }
            }

            .field-value-message {
                color: $warning-color;
                font-weight: bolder;
            }
        }
    }


    .field.hover {
        .field-value {
            .field-value-input-wrapper {
                border-color: $hover-border-color;

                .field-value-input {
                    .value-input-body {
                        opacity: $hover-opacity;
                    }

                    .value-input-ex-symbol {
                        opacity: $focus-opacity;
                    }
                }
            }
        }
    }

    .field.focus {
        .field-value {
            .field-value-input-wrapper {
                border-color: $focusColor;

                .field-value-input {
                    border-color: $focusColor;

                    .value-input-body {
                        opacity: $focus-opacity;
                    }
                    
                    .value-input-ex-symbol {
                        opacity: $focus-opacity;
                    }
                }
            }
        }
    }

    .field.disabled {
        .field-value {
            .field-value-input-wrapper {
                background-color: $disabled-color;
                border-color: $disabled-color;
                
                .value-input {
                    .value-input-body {
                        opacity: $focus-opacity;
                    }
                    
                    .value-input-ex-symbol {
                        opacity: $focus-opacity;
                    }
                }
            }
        }

        .field-required-content i {
            color: $disabled-color;
        }
    }
}

:host.component-size-big input {
    font-size: $font-size-big;
}

:host.component-size-normal input {
    font-size: $font-size-normal;
}

:host.component-size-small input {
    font-size: $font-size-small;
}